using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using OpenQA.Selenium.Support.UI;

using SeleniumExtras.WaitHelpers;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ũ ̹ 
        /// </summary>
        private ChromeDriverService driverService = null;

        /// <summary>
        /// ũ ɼ
        /// </summary>
        private ChromeOptions options = null;

        /// <summary>
        /// ũ ̹
        /// </summary>
        private ChromeDriver driver = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            FormClosing                   += Form_FormClosing;
            this.showButton.Click         += showButton_Click;
            this.autoNavigateButton.Click += autoNavigateButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region    óϱ - Form_FormClosing(sender, e)

        /// <summary>
        ///    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            if(this.driver != null)
            {
                this.driver.Quit();

                this.driver = null;
            }
        }

        #endregion
        #region ũ  ǥ ư Ŭ óϱ - showButton_Click(sender, e)

        /// <summary>
        /// ũ  ǥ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void showButton_Click(object sender, EventArgs e)
        {
            if(this.driverService == null)
            {
                this.driverService = ChromeDriverService.CreateDefaultService();

                this.driverService.HideCommandPromptWindow = true;
            }

            if(this.options == null)
            {
                this.options = new ChromeOptions();

                this.options.AddArgument("--start-maximized");
                this.options.AddArgument("ignore-certificate-errors");
              //this.options.AddArgument("--disable-gpu");

                string userAgent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/113.0.0.0 Safari/537.36";

                this.options.AddArgument($"user-agent={userAgent}");
                this.options.AddArgument("incognito");
                this.options.AddExcludedArgument("enable-automation");
            }

            this.driver = new ChromeDriver(this.driverService, this.options);
        }

        #endregion
        #region ڵ Ž ư Ŭ óϱ - autoNavigateButton_Click(sender, e)

        /// <summary>
        /// ڵ Ž ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void autoNavigateButton_Click(object sender, EventArgs e)
        {
            string urlList = this.urlListTextBox.Text.Trim();

            if(string.IsNullOrEmpty(urlList))
            {
                MessageBox.Show(this, "URL  ϴ.", "INFORMATION", MessageBoxButtons.OK, MessageBoxIcon.Information);

                this.urlListTextBox.SelectAll();

                this.urlListTextBox.Focus();

                return;
            }

            if(this.driver == null)
            {
                MessageBox.Show(this, "ũ ̹  ʾҽϴ.", "INFORMATION", MessageBoxButtons.OK, MessageBoxIcon.Information);

                return;
            }

            INavigation navigation = this.driver.Navigate();

            string[] urlArray = urlList.Split(new[] { Environment.NewLine }, StringSplitOptions.None);

            foreach(string url in urlArray)
            {
                if(string.IsNullOrWhiteSpace(url))
                {
                    continue;
                }

                navigation.GoToUrl(url);

                WebDriverWait wait = new WebDriverWait(driver, TimeSpan.FromSeconds(10));

                wait.Until(ExpectedConditions.ElementIsVisible(By.XPath("/html/body")));

                Thread.Sleep(3000);
            }
        }

        #endregion
    }
}